\chapter{ไฟล์ข้อมูลบรรณานุกรม (BibTeX)}

BibTeX~เป็นส่วนช่วยสำหรับการจัดรูปแบบรายการของเอกสารอ้างอิง ซึ่งโดยปรกติจะใช้งานร่วมกับ \LaTeX~ เพื่อกำหนดรูปแบบของบรรณานุกรมสำหรับเอกสาร วัตถุประสงค์การทำงานของ BibTeX คือทำให้ง่ายต่อการอ้างอิงถึงแหล่งที่มาของเอกสาร และเพื่อให้การอ้างอิงเป็นไปในลักษณะเดียวกัน 

\section{การทำงานของ BibTeX}
การทำงานของ BibTeX จะประกอบไปด้วยไฟล์สามชนิดด้วยกันคือ 
\begin{itemize}
    \item aux: ไฟล์ที่ถูกสร้างด้วย \LaTeX~เมื่อมีการเรียกใช้คำสั่ง \textbackslash cite
    \item bst: ไฟล์ที่ใช้ระบุรูปแบบของการอ้างอิงเอกสารในบรรณานุกรม โดยรายการอ้างอิงจะเกิดจากข้อมูลในไฟล์ .aux
    \item bib: ไฟล์ฐานข้อมูลของรายการเอกสารอ้างอิงทั้งหมดที่ผู้เขียนเอกสารคิดว่าจะใช้
\end{itemize}

การทำงานเริ่มจาก BibTex จะเลือกข้อมูลจาก ไฟล์ .bib โดยอ้างอิงจากข้อมูลในไฟล์ .aux โดยจะได้ ไฟล์ .bbl ออกมา ซึ่งไฟล์นี้ จะจัดเก็บคำสั่งที่ใช้ในการสร้างบรรณานุกรมที่ถูกระบุตามรูปแบบที่อยู่ใน ไฟล์ .bst โดยไฟล์ .bbl นี่สามารถถูกแก้ไขเพิ่มเติมด้วยผู้ใช้งานได้ (ไม่แนะนำสำหรับผู้เริ่มต้น)

\section{โครงสร้างไฟล์ .bib}
ไฟล์ .bib จะประกอบด้วยลิสต์ของเอกสารที่คาดว่าจะถูกอ้างอิง โดยเอกสารนั้นๆจะถูกแบ่งออกเป็นประเภท(type) ต่างๆ เช่น article, book หรือ conference ซึ่งเอกสารแต่ละประเภทก็จะมีข้อมูล(field) ที่ใช้ระบุการอ้างอิงที่แตกต่างกันไป ดังแสดงในโค้ดด้านล่าง

\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@article{knuth:1984,
    title= {Literate Programming},
    author= {Donald E. Knuth},
    journal= {The Computer Journal},
    volume= {27},
    number= {2},
    pages= {97--111},
    year= {1984},
    publisher= {Oxford University Press}
}
@book {abramowitz:1999,  
    author= {Milton Abramowitz and Irene A. Stegun}",  
    title= {A Handbook of Mathematical Functions with Mathematical graphs and tables},
    publisher= {}Dover},  
    year= {1964},  
    address= {New York City},  
    edition= {Ninth Dover Edition, Tenth GPO Edition} 
}
\end{lstlisting}
\noindent 
เมื่อมีการใช้คำสั่ง \textbackslash cite เพื่ออ้างอิงเอกสารใน \LaTeX ตัว BibTeX จะทำการสร้างค่าการอ้างอิงที่ตำแหน่งนั้น และเชื่อมโยงไปยังการออ้างอิงที่อยู่ในบรรณานุกรมซึ่งอยู่ในรูปแบบที่กำหนดไว้ตามไฟล์ .bst 
ดังต่ออย่างต่อไปนี้เมื่อมีการอ้างอิงเอกสารโดยการ \textbackslash cite\{abramowitz:1999\} เมื่อทำการคอมไพล์แล้ว \LaTeX จะสร้างข้อมูลเอกสารอ้างอิง\cite{abramowitz:1999} ในบรรณานุกรมดังรูปที่~\ref{appxA:pic:reference}

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{reference.png}
	\caption{รูปแบบข้อมูลเอกสารอ้างอิงในบรรณานุกรม}
	\label{appxA:pic:reference}
\end{figure}

\section{ประเภทเอกสารอ้างอิง}
แหล่งอ้างอิงที่รองรับได้แก่
\subsection{article}
An article from a journal, magazine, newspaper, or periodical\par\noindent
\textbf{Supported fields}: \textit{\textbf{author}}, \textit{\textbf{title}}, language, \textit{\textbf{journal}}, volume, number, pages, month, \textit{\textbf{year}}, note, url
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@article{ IEEEexample:TBParticle,
author = "N. Kahale and R. Urbanke",
title = "On the Minimum Distance of Parallel
and Serially Concatenated Codes",
journal = IEEE_J_IT,
year = "submitted for publication"
}
\end{lstlisting}

\subsection{book}
A book where the publisher is clearly identifiable.\par\noindent
\textbf{Supported fields}: \textit{\textbf{author}} and/or \textit{\textbf{editor}}, \textit{\textbf{title}}, language, edition, series, address, \textit{\textbf{publisher}}, month, \textit{\textbf{year}}, volume, number, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@book{IEEEexample:book_typical,
  author        = "B. D. Cullity",
  title         = "Introduction to Magnetic Materials",
  publisher     = "Addison-Wesley",
  address       = "Reading, MA",
  year          = "1972"
}
\end{lstlisting}

\subsection{inbook}
A section, such as a chapter, or a page range within a book.\par\noindent
\textbf{Supported fields}:  \textit{\textbf{author}} and/or \textit{\textbf{editor}}, \textit{\textbf{title}},
language, edition, series, address, \textit{\textbf{publisher}},
month, year, volume, number, chapter, type, pages,
note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@inbook{IEEEexample:inbook,
  author        = "H. E. Rose",
  title         = "A Course in Number Theory",
  publisher     = "Oxford Univ. Press",
  address       = "New York, NY",
  year          = "1988",
  chapter       = "3"
}
\end{lstlisting}

\subsection{incollection}
A titled section of a book. Such as a short story within the larger collection of short stories that make up the book.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}},  \textit{\textbf{title}},  \textit{\textbf{booktitle}},
language, edition, series, editor, address,
publisher, month,  \textit{\textbf{year}}, volume, number, chapter,
type, pages, note, url.ear, volume, number, chapter, type, pages,
note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@incollection{IEEEexample:incollection,
  author        = "W. V. Sorin",
  editor        = "D. Derickson",
  title         = "Optical Reflectometry for Component Characterization",
  booktitle     = "Fiber Optic Test and Measurement",
  publisher     = "Prentice-Hall",
  address       = "Englewood Cliffs, NJ",
  year          = "1998"
}
\end{lstlisting}

\subsection{booklet}
A printed work that is bound, but does not have a clearly identifiable publisher or supporting institution.\par\noindent
\textbf{Supported fields}:   author,  \textit{\textbf{title, language}},
howpublished, organization, address, month, year,
note, url.
\newpage\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@booklet{CitekeyBooklet,
  title        = "Canoe tours in {S}weden",
  author       = "Maria Swetla", 
  howpublished = "Distributed at the Stockholm Tourist Office",
  month        = jul,
  year         = 2015
}
\end{lstlisting}

\subsection{manual}
A technical manual for a machine software such as would come with a purchase to explain operation to the new owner.\par\noindent
\textbf{Supported fields}:   author, \textit{\textbf{title}}, language, edition,
howpublished, organization, address, month, year,
note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@manual{CitekeyManual,
  title        = "{R}: A Language and Environment for Statistical Computing",
  author       = "{R Core Team}",
  organization = "R Foundation for Statistical Computing",
  address      = "Vienna, Austria",
  year         = 2018
}
\end{lstlisting}

\subsection{inproceedings/conference}
A paper that has been published in conference proceedings.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}}, \textit{\textbf{title}}, intype,
\textit{\textbf{booktitle}}, language, series, editor, volume,
number, organization, address, publisher, month,
\textit{\textbf{year}}, paper, type, pages, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@inproceedings{CitekeyInproceedings,
  author    = "Holleis, Paul and Wagner, Matthias and Koolwaaij, Johan",
  title     = "Studying mobile context-aware social services in the wild",
  booktitle = "Proc. of the 6th Nordic Conf. on Human-Computer Interaction",
  series    = "NordiCHI",
  year      = 2010,
  pages     = "207--216",
  publisher = "ACM",
  address   = "New York, NY"
}
\end{lstlisting}

\subsection{proceedings}
A conference proceeding.\par\noindent
\textbf{Supported fields}:   editor,  \textit{\textbf{title}}, language, series,
volume, number, organization, address, publisher,
month,  \textit{\textbf{year}}, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@proceedings{CitekeyProceedings,
  editor    = "Susan Stepney and Sergey Verlan",
  title     = "Proceedings of the 17th International Conference on Computation and Natural Computation, Fontainebleau, France",
  series    = "Lecture Notes in Computer Science",
  volume    = "10867",
  publisher = "Springer",
  address   = "Cham, Switzerland",
  year      = 2018
}
\end{lstlisting}

\subsection{mastersthesis}
A thesis written for the Master’s level degree.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}}, \textit{\textbf{title}}, language, type,
\textit{\textbf{school}}, address, month, \textit{\textbf{year}}, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@mastersthesis{CitekeyMastersthesis,
  author  = "Jian Tang",
  title   = "Spin structure of the nucleon in the asymptotic limit",
  school  = "Massachusetts Institute of Technology",
  year    = 1996,
  address = "Cambridge, MA",
  month   = sep
}
\end{lstlisting}

\subsection{phdthesis}
A thesis written for the PhD level degree.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}}, \textit{\textbf{title}}, language, type,
\textit{\textbf{school}}, address, month, \textit{\textbf{year}}, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@phdthesis{CitekeyPhdthesis,
  author  = "Rempel, Robert Charles",
  title   = "Relaxation Effects for Coupled Nuclear Spins",
  school  = "Stanford University",
  address = "Stanford, CA",
  year    = 1956,
  month   = jun
}
\end{lstlisting}

\subsection{techreport}
An institutionally published report such as a report from a school, a government organization, an organization, or a company. This entry type is also frequently used for white papers and working papers.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}}, \textit{\textbf{title}}, language,
howpublished, \textit{\textbf{institution}}, address, number, type,
month, \textit{\textbf{year}}, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@techreport{CitekeyTechreport,
  title       = "{W}asatch {S}olar {P}roject Final Report",
  author      = "Bennett, Vicki and Bowman, Kate and Wright, Sarah",
  institution = "Salt Lake City Corporation",
  address     = "Salt Lake City, UT",
  number      = "DOE-SLC-6903-1",
  year        = 2018,
  month       = sep
}
\end{lstlisting}

\subsection{unpublished}
A document that has not been officially published such as a paper draft or manuscript in preparation.\par\noindent
\textbf{Supported fields}:   \textit{\textbf{author}}, title, language, month,
year, \textit{\textbf{note}}, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@unpublished{CitekeyUnpublished,
  author = "Mohinder Suresh",
  title  = "Evolution: a revised theory",
  year   = 2006
}
\end{lstlisting}

\subsection{electronic}
A document that has been referenced from online source such as internet or webpage .\par\noindent
\textbf{Supported fields}:   author, month, year, title,
language, howpublished, organization, address,
note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@electronic{who.int,
  author = {{WHO | World Health Organization}},
  title = {Types of cardiovascular disease},
  url = {http://www.who.int/cardiovascular\_diseases/en/cvd\_atlas\_01\_types.pdf},
  date = 13,
  month = Sep,
  year = 2013
}
\end{lstlisting}
\newpage
\subsection{patent}
A patent that has been referenced.\par\noindent
\textbf{Supported fields}:  author, title, language, assignee,
address, \textit{\textbf{nationality}}, type, \textit{\textbf{number}}, day, dayfiled,
month, monthfiled, \textit{\textbf{year}} or \textit{\textbf{yearfiled}}, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@patent{bell_1876,
  author        = "A. G. Bell",
  title         = "Improvement in telegraphy",
  nationality   = "United States",
  number        = "174465",
  day           = "7",
  month         = Mar,
  year          = "1876",
  url           = "https://www.google.com/patents/US174465"
}
\end{lstlisting}

\subsection{misc}
Used if none of the other entry types quite match the source. Frequently used to cite web pages, but can be anything from lecture slides to personal notes.\par\noindent
\textbf{Supported fields}:  author, title, language,
howpublished, organization, address, pages, month,
year, note, url.
\par\noindent
\underline{ตัวอย่างการใช้งาน}
\begin{lstlisting}[float=h, language = TeX, basicstyle={\scriptsize}]
@misc{CitekeyMisc,
  title        = "Pluto: The 'Other' Red Planet",
  author       = "{NASA}",
  howpublished = "\url{https://www.nasa.gov/nh/pluto-the-other-red-planet}",
  year         = 2015,
  note         = "Accessed: 2018-12-06"
}
\end{lstlisting}